<html>
<head>
<title>Torrus Project</title>
<link rel="stylesheet" href="torrusdoc.css" type="text/css" />
<!-- $Id$ -->
</head>

<body>

<h1>Torrus: The Data Series Processing Framework</h1>

<p>In short, Torrus is an alternative software platform to
<a href="http://oss.oetiker.ch/mrtg/">MRTG</a>,
<a href="http://cricket.sourceforge.net/">Cricket</a> and
<a href="http://www.cacti.net/">Cacti</a>. In most cases it brings more
flexibility and performance. We are able to poll
<a href="http://goo.gl/tpWIx">1 million SNMP OIDs every 5 minutes
from a modern server</a>.
</p>


<p>
Torrus is designed to be the universal data series processing
framework. Its scalable hierarchical design, application-independent core,
and highly customizable architecture make Torrus an attractive choice
both for small installations and for big enterprise or carrier networks.
Although most of our users deploy Torrus for SNMP monitoring, it might be
useful for data series of any nature. Tobi Oetiker's RRDtool is used for
data storage.
</p>

<p>
See the <a href="http://demo.oetiker.torrus.net/"><strong>Torrus+SIAM+Extopus
demo</strong></a> that illustrates the integration of Torrus with an ISP's
service inventory and a customer self-service portal.
</p>

<p>
<strong>Torrus functional overview slideshow</strong> gives some conceptional
and quick explanations (<a href="torrus-functional-overview.odp">Open Office
presentation</a>, <a href="torrus-functional-overview.pdf">PDF</a>)
</p>

<p>
<strong>Torrus presentation at SwiNOG
meeting</strong>:
<a href="Torrus-Swinog16.odp">Open Office presentation</a>,
<a href="Torrus-Swinog16.pdf">PDF</a>
</p>


<p>
Currently Torrus consists of the following parts:
<ul>

<li>
<strong>Configuration compiler and validator.</strong>
It processes the XML configuration files and saves the configuration
into a database.
</li>

<li>
<strong>View renderer and the web interface.</strong>
They generate HTML and the graphical representation of the datasources
and provide user authentication and authorization.
All generated output is controlled by the configuration parameters
and templates.
The users can easily create their own presentation of data series.
</li>

<li>
<strong>SNMP Collector.</strong>
Thanks to David M. Town's
<a href="http://search.cpan.org/search?module=Net::SNMP">
Net::SNMP Perl module</a>, Torrus has got an extremely efficient SNMP
data poller, with ability to poll dozens of thousands of SNMP variables
from a single server. Modular collector core architecture allows
further extension with new collector and storage types.
Any datasource can have its own polling schedule.
</li>

<li>
<strong>SNMP Device Discovery Tool</strong>.
<em>Devdiscover</em> is a new, modular, flexible, and expandable tool for
automatic generation of Torrus configuration files. New device types
and MIBs are easily added as independent Perl modules. Thanks to our
contributors, the number of supported devices and vendors is constantly
growing.
</li>

<li>
<strong>Billing reports generator</strong>.
Torrus can be configured to store the network traffic usage in an SQL
database (without RRDTools' aggregation and interpolation), and produce
monthly reports on traffic volume and 95th Percentile bandwidth usage.
</li>

<li>
<strong>Threshold monitor.</strong>
All data, regardless of their type and nature,
can be monitored according to the user-defined rules. The rules can also
include the datasource-specific parameters, e.g. boundary values etc.
The following types of action may be combined for event reporting:
1) Displaying the list of alarmed datasources; 2) E-mail notification;
3) SNMP trap; 4) Any custom executable. Thresholds are specified by RPN
expressions.
</li>

</ul>
</p>



<h2>Getting the software</h2>

<ul>
<li>
<a href="http://sourceforge.net/projects/torrus/">Project
home and <strong>downloads</strong></a> at Sourceforge
</li>
<li>
<a href="http://sourceforge.net/scm/?type=git&group_id=119282">Git
repository</a> and
<a href="http://sourceforge.net/apps/mediawiki/torrus/index.php?title=Working_with_Torrus_sources">usage instructions</a>
</li>
<li>
Current <a href="http://torrus.sourceforge.net/devel/">development
snapshots</a> are available for testing
</li>
</ul>


<h2>Documentation</h2>

<ul>
<li>
<strong><a href="http://torrus.wiki.sourceforge.net/">Torrus Wiki</a></strong>
lists some useful information and tips, as well as installation scenarios for
some OS'es.
</li>
<li>
<a href="install.pod.html">Installation Instructions</a>:
system requirements and installation steps
</li>
<li>
<a href="webintf.pod.html">Web Interface Reference</a>:
installation details for the different handlers
</li>
<li>
<a href="rrfw_torrus_migration.pod.html">RRFW to Torrus migration guide</a>:
step by step guide for those having an RRFW installation.
</li>
<li>
<a href="userguide.pod.html">User Guide</a>:
explains what is where and how to start using the system.
</li>
<li>
<a href="scalability.pod.html">Scalability Guide</a>:
advanced setup guidelines for large-scale monitoring platforms.
</li>
<li>
<a href="snmpdiscovery.pod.html">SNMP Discovery User Guide</a>:
Guide to SNMP discovery tools
</li>
<li>
<a href="xmlconfig.pod.html">Configuration Guide</a>:
XML configuration reference
</li>
<li>
<a href="vendorsupport.pod.html">Vendor Support List</a>:
List of vendors and MIBs supported.
</li>
<li>
<a href="manpages/">Manual pages</a>:
all executables documented
</li>
<li>
<a href="reporting_setup.pod.html">Reporting Setup Guide</a>:
Traffic usage and 95th percentile reports
</li>
<li>
<a href="rpnexpr.pod.html">RPN expressions in Torrus</a>:
Torrus-specific features in RPN expressions, as compared to
<i>rrdtool graph</i>
</li>
<li>
<a href="stylingprofile.pod.html">Styling Profile Guide</a>:
how to create your own display styles for Torrus graphs
</li>
<li>
<a href="nodeid_usage.pod.html">Using NodeID for OSS integration</a>:
guidelines for integrating Torrus with external software systems
</li>
<li>
<a href="devdoc/">Development documentation</a>: internals documented,
working drafts, and technical reqirements.
</li>
<li>
<a href="plugins/">Plugins documentation</a>: optional features and
contributions.
</li>
</ul>



<h2>Features of Torrus</h2>

<ul>
<li>
<em>Data-oriented design</em>. Most of the existing frontends are SNMP-centric.
In Torrus, the SNMP collector is not the central part,
but rather one of possible data sources. It is easy to integrate
some existing RRD files that are updated by some external agents.
</li>
<li>
<em>Multiple independent datasource trees</em> in one instance
of Torrus.
</li>
<li>
<em>User authentication and authorization</em>. Users belong to groups,
and each group has privileges to browse a certain subset of trees.
</li>
<li>
Flexible hierarchical <em>configuration in XML</em> format. Multuiple XML
files are processed additively.
</li>
<li>
Externally generated RRD files can be automatically grouped,
based on the filename regular expressions.
</li>
<li>
Flexible representation of the data. One datasource may be displayed in
multiple subtrees of the hierarchy. It allows you to group them at your
convenience.
</li>
<li>
<em>Aberrant behaviour detection</em> based on <em>Holt-Winters prediction</em>
is fully supported (requires rrdtool version 1.1.x). See the
references below for more information.
</li>
<li>
Support for <em>international</em> character sets (Latin1 and Unicode).
</li>
<li>
First open-source complete
<a href="plugins/tp-cisco-cbqos.pod.html">implementation</a>
of
<a href=
"http://www.cisco.com/pcgi-bin/Support/browse/index.pl?i=Technologies&f=773">
Cisco QoS</a> (CISCO-CLASS-BASED-QOS-MIB) discovery and monitoring.
</li>
</ul>



<h2>Product Support</h2>

<p>
Torrus is free software. It is distributed under the
<a href="http://www.gnu.org/licenses/licenses.html#GPL">GNU General
Public License</a>.
</p>
<p>
Please send all your requests, comments, and bug reports to the
<strong><a href="http://lists.sourceforge.net/lists/listinfo/torrus-users">
torrus-users</a></strong> mailing list. Only list subscribers are allowed to
post the messages there. All new release announcements are sent to this list.
</p>

<p>
The development issues of Torrus are discussed in
<strong><a href="http://lists.sourceforge.net/lists/listinfo/torrus-devel">
torrus-devel</a></strong> mailing list.
Copies of all CVS commits are posted to
<strong><a href="http://lists.sourceforge.net/lists/listinfo/torrus-commit">
torrus-commit</a></strong> mailing list.
</p>

<p>
Archives of the old mailing lists are available for
<strong><a href="http://lists.sourceforge.net/lists/listinfo/rrfw-users">
rrfw-users</a></strong> and
<strong><a href="http://lists.sourceforge.net/lists/listinfo/rrfw-devel">
rrfw-devel</a></strong> .
</p>


<p>
<strong>Commercial support</strong> for Torrus is provided by:
<blockquote>
<a href="http://www.k-open.com/">K-Open GmbH</a><br>
Switzerland<br>
Direct phone: +41 79 407 0224<br>
Calling from USA and Canada: 1-240-846-6039<br>
</blockquote>
Commercial support includes:
<ul>
<li>Software installation and customizing</li>
<li>Development of custom user data import utilities</li>
<li>Development of new Torrus features</li>
<li>Software maintenance contracts</li>
</ul>
For more details about commercial support, please contact us
<a href="mailto:info@k-open.com">by email</a>.
</p>

<h2>SNMP MIBs</h2>

By courtesy of Tobi Oetiker, we are using the subtree of
<a href="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/iana/">
RRDtool Enterprise ID</a>.

Torrus is now capable of sending the SNMPv2c traps, with the variables
described in the corresponding MIB file.

<ul>
<li>
<a href="RRDTOOL-SMI.txt">RRDTOOL-SMI</a>: the original file from
<a href="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/iana/">
RRDtool enterprise tree</a>
</li>
<li>
<a href="TORRUS-MIB.txt">Torrus-MIB</a>: The MIB which describes the SNMPv2c
traps sent by <tt>action_snmptrap</tt> (see <i>Manpages</i> for
details)
</li>
</ul>


<h2>References</h2>

<ul>

<li>
Torrus was the new name for RRFW, the Round Robin Database
Framework. The changes are summarized in the
<a href="devdoc/torrus_roadmap.pod.html">transition roadmap</a>.
Old RRFW documentation is available at
<a href="http://rrfw.sourceforge.net/">RRFW home page</a>.
</li>

<li>
Development of RRFW releases 0.0.1 to 0.0.7, as well as development and testing
of Cisco class-based QoS monitoring was sponsored by
<a href="http://www.cablecom.ch/">Cablecom GmbH</a>
Internet Core Routing Services Team.
<br>
<font size="-1">
Cablecom is the leading country-wide cable-TV and Internet
provider in Switzerland.
</font>
</li>

<li>
This project would not even start without
<a href="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/index.html">
Tobi Oetiker's RRDTool</a>.
<br>
<font size="-1">
RRD is a very efficient and popular system to store and
display time-series data.
</font>
</li>

<li>
Many concepts and ideas were taken from
<a href="http://cricket.sourceforge.net">Cricket</a>.
<br>
<font size="-1">
Cricket is a widely used and very efficient network monitoring system.
However, its limitations were actually the reason to start this project.
</font>
</li>

<li>
Jake Brutlag.
<a href="http://www.usenix.org/events/lisa2000/brutlag.html">
Aberrant Behavior Detection in Time Series for Network Service Monitoring</a>.
<br>
LISA 2000 paper.
<br>
<font size="-1">
The article gives the basic theory overview of Holt-Winters forecasting
algorithm, and describes its implementation in RRDTool.
</font>
</li>

<li>
Jake Brutlag.
<a href="http://cricket.sourceforge.net/aberrant/rrd_hw.htm">
Notes on RRDTOOL implementation of Aberrant Behavior Detection</a>.
<br>
<font size="-1">
The article describes the implementation of
aberrant behavior detection for RRDTOOL.
</font>
</li>

</ul>

<h2>Credits</h2>

<ul>

<li>
Chris Amley. Xylan switches SNMP discovery
</li>

<li>
<a href="mailto:sbrooks@binary-solutions.net">Scott Brooks</a>.
Atmel wireless devices SNMP discovery
</li>

<li>
<a href="mailto:abush@microcenter.com">Aaron Bush</a>.
Contributed APC and HP vendor templates.
</li>

<li>
Shawn Ferry &lt;sferry at sevenspace.com&gt;
&lt;lalartu at obscure.org&gt;.
Many contributions in various parts.
</li>

<li>
<a href="mailto:mh+torrus@zugschlus.de">Marc Haber</a>.
Lots of bug reports and architecture ideas.
</li>

<li>
<a href="mailto:roman@hochu.li">Roman Hochuli</a>.
Bug reports and new feature ideas.
Vendor templates for Ascend and DOCSIS.
</li>

<li>
<a href="mailto:ian@holsman.net">Ian Holsman</a>
&lt;<a href="http://holsman.net">http://holsman.net</a>&gt;.
Adapted the <a href="http://bluerobot.com">bluerobot.com</a>
HTML layout design for Torrus.
</li>

<li>
<a href="mailto:tech@gordphilpott.com">Gord Philpott</a>.
Numerous bug reports.
</li>

<li>
<a href="mailto:christian.schnidrig@gmx.ch">Christian Schnidrig</a>.
Architecture ideas and interface improvements.
</li>

<li>
<a href="mailto:jurij@wooyd.org">Jurij Smakov</a>.
Contributed in manpages creation. Maintainer of
<a href="http://pkg-torrus.alioth.debian.org/">Torrus Debian package</a>
</li>

<li>
<a href="mailto:nistor@snickers.org">Jon Nistor</a>.
Bug reports and contributions for JunOS, Cisco SCE and other vendors discovery.
</li>


</ul>

<h2>Companies using Torrus</h2>

<div class="Custlogos">

<a href="http://www.adtaq.com/">
<img class="Custlogo"
src="logo/adtaq.png" width="120" height="24"
alt="Adtaq Internet, LLC, Coolocation service provider in Issaquah, WA, USA"/></a>

<a href="http://www.binarybroadband.com/">
<img class="Custlogo"
src="logo/binary_solutions.png" width="120" height="30"
alt="Binary Solutions Ltd., wireless technology company, Canada"/></a>

<a href="http://www.bluewin.ch/">
<img class="Custlogo"
src="logo/bluewin.png" width="100" height="19"
alt="Bluewin AG, large ADSL provider in Switzerland"/></a>

<a href="http://www.cablecom.ch/">
<img class="Custlogo"
src="logo/cablecom.png" width="100" height="57"
alt="upc cablecom GmbH,
largest cable TV and Internet provider in Switzerland"/></a>

<a href="http://www.fibrenoire.ca/">
<img class="Custlogo"
src="logo/fibrenoire.png" width="120" height="22"
alt="Fibre Noire Internet Inc., a business service provider in Montreal, Canada"/></a>

<a href="http://www.gpstechnik.ch/">
<img class="Custlogo"
src="logo/gpstechnik.png" width="100" height="54"
alt="GPS Technik AG, network solution provider in Switzerland"/></a>

<a href="http://www.gsid.net/">
<img class="Custlogo"
src="logo/gsid.png" width="96" height="55"
alt=
"GSID.net, an international hosting provider"/></a>

<a href="http://www.kfn-ag.ch/">
<img class="Custlogo"
src="logo/kfn.png" width="98" height="33"
alt="Kabelfernsehen Nidwalden AG,
cable TV and Internet provider in Switzerland"/></a>

<a href="http://www.nexellent.ch/">
<img class="Custlogo"
src="logo/nexellent.png" width="120" height="41"
alt="Nexellent AG,
Internet services and consulting company in Switzerland"/></a>

<a href="http://www.prioritycolo.com/">
<img class="Custlogo"
src="logo/prioritycolo.png" width="100" height="38"
alt=
"Priority Colo Inc., large colocation services provider, Toronto, Canada"/></a>

<a href="http://www.quicknet.ch/">
<img class="Custlogo"
src="logo/quicknet.png" width="100" height="30"
alt="Kabelfernsehen Boedeli AG,
cable TV and Internet provider in Interlaken, Switzerland"/></a>

<a href="http://www.sevenspace.com/">
<img class="Custlogo"
src="logo/sevenspace.png" width="140" height="28"
alt="SevenSpace Inc., outsourcing services provider, U.S."/></a>

<a href="http://www.syscovery.com/">
<img class="Custlogo"
src="logo/syscovery.png" width="149" height="41"
alt="syscovery AG, an IT services company, Germany"/></a>

<a href="http://www.torix.net/">
<img class="Custlogo"
src="logo/torix.png" width="100" height="29"
alt=
"TorIX, The Toronto Internet Exchange"/>
</a>


</div>
<hr>
<p>Copyright &copy; 2002-2007 Stanislav Sinyagin
&lt;<a href="mailto:ssinyagin@yahoo.com">ssinyagin@yahoo.com</a>&gt;</p>
<A href="http://sourceforge.net">
<IMG src="http://sourceforge.net/sflogo.php?group_id=119282&amp;type=1"
 width="88" height="31" border="0" alt="SourceForge Logo">
</A>


</body>
</html>
